﻿@model Jb.Framework.Common.Forms.JbForm
@{
    Layout = null;
}
<div id="ng-app" class="formBuilder JbForm dynamic">
    <div data-ng-controller="formBuilder">
        <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
            <h3 id="myModalLabel" class="text-left">Edit Form</h3>
        </div>
        <div class="modal-body inline">
            <div class="form-preview">
                <h3 class="form-title" data-jb-edit-caption>
                    <span ng-hide="CaptionIsEditing" ng-click="CaptionIsEditing = true; _Title = form.Title" class="title">{{form.Title}}</span>
                    <a ng-hide="CaptionIsEditing" ng-click="CaptionIsEditing = true; _Title = form.Title" class="edit">(Edit form title)</a>
                    <input ng-hide="!CaptionIsEditing" ng-model="form.Title" pattern="/[a-zA-Z0-9 &]+/" class="input-large" type="text" maxlength="20" style="width: 300px;" />
                    <a ng-click="saveSectionTitleEdit()" ng-hide="!CaptionIsEditing" class="save">Save</a>
                    <a ng-click="CaptionIsEditing = false; form.Title = _Title" ng-hide="!CaptionIsEditing" class="cancel">Cancel</a>
                </h3>
                <ul data-ng-if="form" data-ui-sortable="sortableOptions" data-ng-model="form.Elements">
                    <li class="jb-control" data-ng-class="[e.Type , e.CurrentMode , e.size]" data-elementid="{{e.ElementId}}" data-ng-repeat="e in form.Elements" data-index="{{$index}}" data-jb-editor="e"></li>
                </ul>
            </div>

            <div class="form-current-question" ng-class="{open: currentElement != null}">
                <div class="question-container">
                    <div class="step1 container">
                        <div ng-hide="currentElement.Type == 'JbSection'">
                            <label for="currentElementType">Element type</label>
                            <select id="currentElementType" data-ng-model="currentElement.Type" class="full-width" data-ng-options="t.Type as t.TypeTitle for t in elementTypes | isNotSection" data-ng-change="adaptNewElement()" class="input-xxlarge"></select>
                        </div>
                    </div>

                    <div data-ng-if="currentElement.Type" class="step2 container">
                        <div>
                            <div data-ng-if="currentElement.Type == 'JbSection'">
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label for="currentElementValue">Section title</label>
                                        <input id="currentElementValue" type="text" class="full-width" data-ng-model="currentElement.Title" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    @* <div class="span6">
                                            <label for="currentElementHelpText">Help text</label>
                                            <input id="currentElementHelpText" type="text" class="full-width" data-ng-model="currentElement.HelpText" />
                                        </div>*@
                                    <div class="span6">
                                        <label for="currentElementVisibleMode">Visibility Mode</label>
                                        <select id="currentElementVisibleMode" data-ng-model="currentElement.VisibleMode" class="full-width" data-ng-options="v as v for v in VisibilityModes"></select>
                                    </div>
                                </div>
                            </div>

                            <div data-ng-if="currentElement.Type == 'JbTextArea'">
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label for="currentElementTitle">Question</label>
                                        <input id="currentElementTitle" type="text" class="full-width" data-ng-model="currentElement.Title" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementValue">Default answer</label>
                                        <textarea id="currentElementValue" type="text" class="full-width" data-ng-model="currentElement.Value"></textarea>
                                    </div>
                                    <div class="span6">
                                        <label for="currentElementHelpText">Help text</label>
                                        <input id="currentElementHelpText" type="text" class="full-width" data-ng-model="currentElement.HelpText" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementVisibleMode">Visibility Mode</label>
                                        <select id="currentElementVisibleMode" data-ng-model="currentElement.VisibleMode" class="full-width" data-ng-options="v as v for v in VisibilityModes"></select>
                                    </div>
                                    <div class="span6">
                                        <label for="currentElementPlaceholder">Placeholder text</label>
                                        <input id="currentElementPlaceholder" type="text" class="full-width" data-ng-model="currentElement.PlaceHolder" />
                                    </div>
                                </div>
                                <h4 style="margin-top: 10px">Validations:</h4>
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label>
                                            Is Required
                                            <input data-jb-icheck data-is-validation-required="true" type="checkbox" class="full-width" data-ng-change="isRequiredChange()" data-ng-model="currentElement.IsRequired" />
                                        </label>
                                    </div>
                                </div>
                            </div>

                            <div data-ng-if="currentElement.Type == 'JbTextBox'">
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label for="currentElementTitle">Question</label>
                                        <input id="currentElementTitle" type="text" class="full-width" data-ng-model="currentElement.Title" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementValue">Default answer</label>
                                        <input id="currentElementValue" type="text" class="full-width" data-ng-model="currentElement.Value" />
                                    </div>
                                    <div class="span6">
                                        <label for="currentElementHelpText">Help text</label>
                                        <input id="currentElementHelpText" type="text" class="full-width" data-ng-model="currentElement.HelpText" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementVisibleMode">Visibility Mode</label>
                                        <select id="currentElementVisibleMode" data-ng-model="currentElement.VisibleMode" class="full-width" data-ng-options="v as v for v in VisibilityModes"></select>
                                    </div>
                                    <div class="span6">
                                        <label for="currentElementPlaceholder">Placeholder text</label>
                                        <input id="currentElementPlaceholder" type="text" class="full-width" data-ng-model="currentElement.PlaceHolder" />
                                    </div>
                                </div>
                                <h4 style="margin-top: 10px">Validations:</h4>
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label>
                                            Is Required
                                            <input data-jb-icheck data-is-validation-required="true" type="checkbox" class="full-width" data-ng-change="isRequiredChange()" data-ng-model="currentElement.IsRequired" />
                                        </label>
                                    </div>
                                </div>
                            </div>

                            <div data-ng-if="currentElement.Type == 'JbAddress'">
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label for="currentElementTitle">Question</label>
                                        <input id="currentElementTitle" type="text" class="full-width" data-ng-model="currentElement.Title" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementValue">Default answer</label>
                                        <input id="currentElementValue" type="text" class="full-width" data-ng-model="currentElement.Value" />
                                    </div>
                                    <div class="span6">
                                        <label for="currentElementHelpText">Help text</label>
                                        <input id="currentElementHelpText" type="text" class="full-width" data-ng-model="currentElement.HelpText" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementVisibleMode">Visibility Mode</label>
                                        <select id="currentElementVisibleMode" data-ng-model="currentElement.VisibleMode" class="full-width" data-ng-options="v as v for v in VisibilityModes"></select>
                                    </div>
                                    <div class="span6">
                                        <label for="currentElementPlaceholder">Placeholder text</label>
                                        <input id="currentElementPlaceholder" type="text" class="full-width" data-ng-model="currentElement.PlaceHolder" />
                                    </div>
                                </div>
                                <h4 style="margin-top: 10px">Validations:</h4>
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label>
                                            Is Required
                                            <input data-jb-icheck data-is-validation-required="true" type="checkbox" class="full-width" data-ng-change="isRequiredChange()" data-ng-model="currentElement.IsRequired" />
                                        </label>
                                    </div>
                                </div>
                            </div>

                            <div data-ng-if="currentElement.Type == 'JbNumber'">
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label for="currentElementTitle">Question</label>
                                        <input id="currentElementTitle" type="text" class="full-width" data-ng-model="currentElement.Title" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementValue">Default answer</label>
                                        <input id="currentElementValue" type="text" class="full-width" data-ng-model="currentElement.Value" />
                                    </div>
                                    <div class="span6">
                                        <label for="currentElementHelpText">Help text</label>
                                        <input id="currentElementHelpText" type="text" class="full-width" data-ng-model="currentElement.HelpText" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementPlaceholder">Placeholder text</label>
                                        <input id="currentElementPlaceholder" type="text" class="full-width" data-ng-model="currentElement.PlaceHolder" />
                                    </div>
                                    <div class="span6">
                                        <label for="currentElementVisibleMode">Visibility Mode</label>
                                        <select id="currentElementVisibleMode" data-ng-model="currentElement.VisibleMode" class="full-width" data-ng-options="v as v for v in VisibilityModes"></select>
                                    </div>
                                </div>
                                <h4 style="margin-top: 10px">Validations:</h4>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="minValValidation">Min value</label>
                                        <input id="minValValidation" type="number" class="full-width" data-ng-model="currentElement.MinVal" />
                                    </div>
                                    <div class="span6">
                                        <label for="maxValValidation">Max value</label>
                                        <input id="maxValValidation" type="number" class="full-width" data-ng-model="currentElement.MaxVal" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label>
                                            Is Required
                                            <input data-jb-icheck data-is-validation-required="true" type="checkbox" class="full-width" data-ng-change="isRequiredChange()" data-ng-model="currentElement.IsRequired" />
                                        </label>
                                    </div>
                                </div>
                            </div>

                            <div data-ng-if="currentElement.Type == 'JbPhone'">
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label for="currentElementTitle">Question</label>
                                        <input id="currentElementTitle" type="text" class="full-width" data-ng-model="currentElement.Title" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementValue">Default answer</label>
                                        <input id="currentElementValue" type="text" class="full-width" data-ng-model="currentElement.Value" />
                                    </div>
                                    <div class="span6">
                                        <label for="currentElementHelpText">Help text</label>
                                        <input id="currentElementHelpText" type="text" class="full-width" data-ng-model="currentElement.HelpText" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementPlaceholder">Placeholder text</label>
                                        <input id="currentElementPlaceholder" type="text" class="full-width" data-ng-model="currentElement.PlaceHolder" />
                                    </div>
                                    <div class="span6">
                                        <label for="currentElementVisibleMode">Visibility Mode</label>
                                        <select id="currentElementVisibleMode" data-ng-model="currentElement.VisibleMode" class="full-width" data-ng-options="v as v for v in VisibilityModes"></select>
                                    </div>
                                </div>
                                <h4 style="margin-top: 10px">Validations:</h4>
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label>
                                            Is Required
                                            <input data-jb-icheck data-is-validation-required="true" type="checkbox" class="full-width" data-ng-change="isRequiredChange()" data-ng-model="currentElement.IsRequired" />
                                        </label>
                                    </div>
                                </div>
                            </div>

                            <div data-ng-if="currentElement.Type == 'JbEmail'">
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label for="currentElementTitle">Question</label>
                                        <input id="currentElementTitle" type="text" class="full-width" data-ng-model="currentElement.Title" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementValue">Default answer</label>
                                        <input id="currentElementValue" type="text" class="full-width" data-ng-model="currentElement.Value" />
                                    </div>
                                    <div class="span6">
                                        <label for="currentElementHelpText">Help text</label>
                                        <input id="currentElementHelpText" type="text" class="full-width" data-ng-model="currentElement.HelpText" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementPlaceholder">Placeholder text</label>
                                        <input id="currentElementPlaceholder" type="text" class="full-width" data-ng-model="currentElement.PlaceHolder" />
                                    </div>
                                    <div class="span6">
                                        <label for="currentElementVisibleMode">Visibility Mode</label>
                                        <select id="currentElementVisibleMode" data-ng-model="currentElement.VisibleMode" class="full-width" data-ng-options="v as v for v in VisibilityModes"></select>
                                    </div>
                                </div>
                                <h4 style="margin-top: 10px">Validations:</h4>
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label>
                                            Is Required
                                            <input data-jb-icheck data-is-validation-required="true" type="checkbox" class="full-width" data-ng-change="isRequiredChange()" data-ng-model="currentElement.IsRequired" />
                                        </label>
                                    </div>
                                </div>
                            </div>

                            <div data-ng-if="currentElement.Type == 'paragraphInput'">
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementTitle">Question</label>
                                        <input id="currentElementTitle" type="text" class="full-width" data-ng-model="currentElement.Title" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementValue">Default answer</label>
                                        <textarea id="currentElementValue" type="text" class="full-width" data-ng-model="currentElement.Value"></textarea>
                                    </div>
                                    <div class="span6">
                                        <label for="currentElementHelpText">Help text</label>
                                        <input id="currentElementHelpText" type="text" class="full-width" data-ng-model="currentElement.HelpText" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label for="currentElementPlaceholder">Placeholder text</label>
                                        <input id="currentElementPlaceholder" type="text" class="full-width" data-ng-model="currentElement.PlaceHolder" />
                                    </div>
                                </div>
                                <h4 style="margin-top: 10px">Validations:</h4>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementIsValidationsType">Input type</label>
                                        <input id="currentElementIsValidationsType" type="text" class="full-width" data-ng-model="currentElement.Validations.Type" />
                                    </div>
                                    <div class="span6">
                                        <label>
                                            Is Required
                                            <input data-jb-icheck data-is-validation-required="true" type="checkbox" class="full-width" data-ng-model="currentElement.IsRequired" />
                                        </label>
                                    </div>
                                </div>
                            </div>

                            <div data-ng-if="currentElement.Type == 'JbParagraph'">
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementTitle">Paragraph title</label>
                                        <input id="currentElementTitle" type="text" class="full-width" data-ng-model="currentElement.Title" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label for="currentElementValue">Paragraph body</label>
                                        <textarea id="currentElementValue" class="full-width" data-ng-model="currentElement.Value"></textarea>
                                    </div>
                                </div>
                            </div>

                            <div data-ng-if="currentElement.Type == 'multipleChoice'">
                                <div>
                                    <label for="currentElementTitle">Question</label>
                                    <input id="currentElementTitle" type="text" class="full-width" data-ng-model="currentElement.Title" />
                                </div>
                                <div class="row-fluid">
                                    <div class="span7">
                                        <div>
                                            <label for="currentElementValue">Choices</label>
                                            <ul class="well" data-ui-sortable="sortableOptions" data-ng-model="currentElement.Options">
                                                <li data-ng-repeat="o in currentElement.Options">
                                                    {{o.Title}}
                                                    <i data-ng-click="deleteInArray($index,currentElement.Options)" class="cursor-pointer pull-right icon-remove-sign"></i>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    <div class="span5">
                                        <label for="currentElementValue">Add choices</label>
                                        <div class="form-inline">
                                            <input id="currentElementTitle" class="input-medium" type="text" data-ng-model="newOption.Title" />
                                            <button data-ng-if="newOption" data-ng-click="addOptionWithRandomValue(newOption.Title,currentElement.Options)" class="btn btn-success">Add</button>
                                        </div>
                                    </div>
                                </div>
                                <div>
                                    <label for="currentElementValue">Default answer</label>
                                    <select class="full-width" data-ng-model="currentElement.Value" data-ng-options="o.Value as o.Title for o in currentElement.Options"></select>
                                </div>
                                <div>
                                    <label for="currentElementHelpText">Help text</label>
                                    <input id="currentElementHelpText" type="text" class="full-width" data-ng-model="currentElement.HelpText" />
                                </div>
                            </div>

                            <div data-ng-if="currentElement.Type == 'JbCheckBoxList'">
                                <div>
                                    <label for="currentElementTitle">Question</label>
                                    <input id="currentElementTitle" type="text" class="full-width" data-ng-model="currentElement.Title" />
                                </div>
                                <div class="row-fluid">
                                    <div class="span7">
                                        <div>
                                            <label for="currentElementValue">Choices</label>
                                            <ul class="well" data-ui-sortable="sortableOptions" data-ng-model="currentElement.Options">
                                                <li data-ng-repeat="o in currentElement.Options">
                                                    {{o.Title}}
                                                    <i data-ng-click="deleteInArray($index,currentElement.Options)" class="cursor-pointer pull-right icon-remove-sign"></i>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    <div class="span5">
                                        <label>Add choices</label>
                                        <div class="form-inline">
                                            <label for="currentElementValue">Title</label>
                                            <input id="currentElementTitle" class="full-width input-medium" type="text" data-ng-model="newOption.Title" />
                                        </div>
                                        <div class="form-inline">
                                            <label>
                                                Default Value
                                                <input data-jb-icheck type="checkbox" data-ng-model="newOption.Value" />
                                            </label>
                                        </div>
                                        <button data-ng-if="newOption.Title" data-ng-click="addNewOptionToArray(newOption.Title,newOption.Value,currentElement.Options)" class="cursor-pointer btn btn-success">Add</button>
                                    </div>
                                </div>
                                <div>
                                    <label for="currentElementHelpText">Help text</label>
                                    <input id="currentElementHelpText" type="text" class="full-width" data-ng-model="currentElement.HelpText" />
                                </div>
                            </div>

                            <div data-ng-if="currentElement.Type == 'JbCheckBox'">
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label for="currentElementTitle">Question</label>
                                        <input id="currentElementTitle" type="text" class="full-width" data-ng-model="currentElement.Title" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementHelpText">Help text</label>
                                        <input id="currentElementHelpText" type="text" class="full-width" data-ng-model="currentElement.HelpText" />
                                    </div>
                                    <div class="span6">
                                        <label style="margin-top: 35px;">
                                            Default answer
                                            <input data-jb-icheck type="checkbox" class="full-width icheck" data-ng-model="currentElement.Value" />
                                        </label>
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label for="currentElementHelpText">Visibility Mode</label>
                                        <select id="currentElementVisibleMode" data-ng-model="currentElement.VisibleMode" class="full-width" data-ng-options="v as v for v in VisibilityModes"></select>
                                    </div>
                                </div>
                            </div>

                            <div data-ng-if="currentElement.Type == 'JbDropDown'">
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label for="currentElementTitle">Question</label>
                                        <input id="currentElementTitle" type="text" class="full-width" data-ng-model="currentElement.Title" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <div>
                                            <label for="currentElementValue">Choices</label>
                                            <ul class="well" data-ui-sortable="sortableOptions" data-ng-model="currentElement.Items">
                                                <li data-ng-repeat="o in currentElement.Items">
                                                    {{o.Text}}
                                                    <i data-ng-click="deleteInArray($index,currentElement.Items)" class="cursor-pointer pull-right icon-remove-sign"></i>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    <div class="span6">
                                        <label for="currentElementValue">Add choices</label>
                                        <div class="form-inline">
                                            <input id="currentElementTitle" class="input-medium" type="text" data-ng-model="newOption.Text" />
                                            <button data-ng-if="newOption" data-ng-click="addOptionWithRandomValue(newOption.Text,currentElement.Items)" class="btn btn-success">Add</button>
                                        </div>
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label for="currentElementValue">Default answer</label>
                                        <select class="full-width" data-ng-model="currentElement.Value" data-ng-options="o.Value as o.Text for o in currentElement.Items"></select>
                                    </div>
                                    <div class="span6">
                                        <label for="currentElementHelpText">Help text</label>
                                        <input id="currentElementHelpText" type="text" class="full-width" data-ng-model="currentElement.HelpText" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label for="currentElementHelpText">Visibility Mode</label>
                                        <select id="currentElementVisibleMode" data-ng-model="currentElement.VisibleMode" class="full-width" data-ng-options="v as v for v in VisibilityModes"></select>
                                    </div>
                                </div>
                                <h4 style="margin-top: 10px">Validations:</h4>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label>
                                            Is Required
                                            <input data-jb-icheck data-is-validation-required="true" type="checkbox" class="full-width" data-ng-change="isRequiredChange()" data-ng-model="currentElement.IsRequired" />
                                        </label>
                                    </div>
                                </div>
                            </div>

                            <div data-ng-if="currentElement.IsCustomElement==true">
                                <div class="row-fluid">
                                    <div class="span12">
                                        <label for="currentElementTitle">Element title</label>
                                        <input id="currentElementTitle" type="text" class="full-width" data-ng-model="currentElement.Title" />
                                    </div>
                                </div>
                                <div class="row-fluid">
                                    <div class="span6">
                                        <label>
                                            Is Required
                                            <input data-jb-icheck data-is-validation-required="true" type="checkbox" class="full-width" data-ng-change="isRequiredChange()" data-ng-model="currentElement.IsRequired" />
                                        </label>
                                    </div>
                                </div>
                                @* <div class="row-fluid">
                                        <div class="span6">
                                            <label for="currentElementHelpText">Help text</label>
                                            <input id="currentElementHelpText" type="text" class="full-width" data-ng-model="currentElement.HelpText" />
                                        </div>
                                    </div>*@
                            </div>
                        </div>
                    </div>
                    <div class="container">
                        <div ng-if="currentElement.Type != null && currentElement.Type != '' && currentElement.Type != 'JbSection'">
                            <h4 style="margin-top: -30px">Preview:</h4>
                            <div class="well well-small">
                                <div class="jb-control preview" data-ng-class="[e.Type , e.CurrentMode , e.size]" data-elementid="{{currentElement.ElementId}}" data-index="0" data-jb-editor="currentElement"></div>
                            </div>
                        </div>
                        <button type="button" class="btn btn-grey pull-left" data-ng-click="addOrUpdate.setToAdd()">Cancel</button>
                        <button data-ng-if="currentElement.Type" type="button" class="btn btn-success pull-right" data-ng-click="addOrUpdate.process()">{{addOrUpdate.processTitle}}</button>
                        <div class="clearfix"></div>
                    </div>
                </div>
            </div>
        </div>
        <div class="modal-footer text-right">
            @using (Ajax.BeginForm("Build", "FormBuilder", new AjaxOptions { HttpMethod = "Post", OnSuccess = "JbAjaxSuccess", OnFailure = "JbAjaxFailure" }))
            {
                <button class="btn btn-grey pull-left" data-toggle="modal" data-dismiss="modal">Close</button>
                <span type="button" id="NewQuestion" ng-hide="true" class="" data-ng-click="currentElement.Type = ''" data-ng-disabled="addOrUpdate.isUpdating"></span>
                <button type="button" id="NewSection" class="btn btn-primary" data-ng-click="currentElement.Type = 'JbSection'; addNewSection()" data-ng-disabled="addOrUpdate.isUpdating">Add New Section</button>
                <button class="btn btn-success" type="submit">Save Form</button>
                <input type="hidden" id="formJson" name="formJson" value="{{form}}" />
            }
        </div>
    </div>
</div>
@Scripts.Render("~/bundles/formBuilder")
<script type="text/javascript">
    function JbAjaxSuccess(data) {
        try {
            CloseCallSecondPopUp();
            FormBuilderClosed();
        } catch (ex) { }
    }
    function JbAjaxFailure(data) {
        console.log(data);
        alert("oh no!\nan unwanted error occurred");
    }
</script>
<script type="text/javascript">
    'use strict';
    console.log("FormBuilder is running");
    var FormBuilderApp = angular.module('FormBuilderApp', ['ngSanitize', 'ngRoute', 'ui.bootstrap', 'ui.sortable']);
    FormBuilderApp.filter('unsafe', function ($sce) {
        return function (val) {
            return $sce.trustAsHtml(val);
        };
    });
    FormBuilderApp.filter('isNotSection', function ($sce) {
        return function (val) {
            var controls = [];
            angular.forEach(val, function (dval, key) {
                if (dval.Type != "JbSection") {
                    controls.push(dval);
                }
            });
            return controls;
        };
    });
    FormBuilderApp.filter('filterSpecialChars', function ($sce) {
        return function (val) {
            return val.replace(/[^a-z0-9\s]/gi, '');
        };
    });
    FormBuilderApp.directive('jbIcheck', function ($timeout, $parse, $rootScope) {
        return {
            link: function ($scope, element, $attrs) {
                return $timeout(function () {
                    var ngModelGetter, value;
                    ngModelGetter = $parse($attrs['ngModel']);
                    value = $parse($attrs['ngValue'])($scope);
                    return $(element).iCheck({
                        checkboxClass: 'icheckbox_square-orange',
                        radioClass: 'iradio_square-orange'
                    }).on('ifChanged', function (event) {
                        if ($(element).attr('type') === 'checkbox' && $attrs['ngModel']) {
                            $scope.$apply(function () {

                                if ($attrs['isValidationRequired']) {
                                    if (event.target.checked) {
                                        angular.forEach($rootScope.global.currentElement.Validations, function (val, key) {
                                            if (val.Type == "Required") {
                                                return;
                                            }
                                        });
                                        var requiredValidation = {};
                                        requiredValidation.Type = "Required";
                                        requiredValidation.Message = "This field is required";
                                        requiredValidation.IsChecked = true;
                                        $rootScope.global.currentElement.Validations.push(requiredValidation);
                                    } else {
                                        angular.forEach($rootScope.global.currentElement.Validations, function (val, key) {
                                            if (val.Type == "Required") {
                                                $rootScope.global.currentElement.Validations.splice(key, 1);
                                            }
                                        });
                                    }
                                }

                                return ngModelGetter.assign($scope, event.target.checked);
                            });
                        }
                        if ($(element).attr('type') === 'radio' && $attrs['ngModel']) {
                            return $scope.$apply(function () {
                                return ngModelGetter.assign($scope, value);
                            });
                        }
                    });
                });
            }
        };
    });
    FormBuilderApp.directive('ngType', function ($compile) {
        return {
            restrict: 'A',
            scope: {
                ngType: "="
            },
            link: function (scope, element, attrs) {
                scope.$watch('ngType', function () {
                    element.prop("type", scope.ngType);
                });
            }
        };
    });
    FormBuilderApp.directive('jbCollapse', function ($compile) {
        return {
            restrict: 'A',
            link: function (scope, element, attrs) {
                var isDragging = false, isDown = false, dontCollapseClicked = false, x, y;
                element.mousedown(function (e) {
                    isDown = true;
                    x = e.pageX;
                    y = e.pageY;
                });
                element.mousemove(function (e) {
                    if (isDown && x != e.pageX && y != e.pageY)
                        isDragging = true;
                });
                element.parent().find(".jb-inner-controll-holder").slideUp();
                element.addClass("closed");
                element.mouseup(function () {
                    setTimeout(function () {
                        if (!isDragging && !dontCollapseClicked) {
                            if (element.hasClass("closed")) {
                                angular.element(".jb-inner-controll-holder").slideUp();
                                angular.element(".jb-section-title").addClass("closed");
                            }
                            element.parent().find(".jb-inner-controll-holder").slideToggle();
                            element.toggleClass("closed");
                        }
                        isDragging = isDown = false;
                    }, 1);
                });
                element.find(".dont-collapse").click(function () {
                    dontCollapseClicked = true;
                    setTimeout(function () {
                        dontCollapseClicked = false;
                    }, 500);
                });
                element.find(".edit").on("click", function () {
                    element.find("input").width(element.find("input").val().length * 10 + 10).focus();
                });
                element.find("input").on("keyup", function (e) {
                    if (e.which == 13) {
                        if (element.find("input").val().length() < 1)
                            alert("Section title is required");
                        else
                            element.find(".save").click();
                    } else if (e.which == 27) {
                        e.stopPropagation();
                        element.find(".cancel").click();
                    }
                    element.find("input").width(element.find("input").val().length * 10 + 10);
                });
                element.find("input").on("blur", function (e) {
                    if (element.find("input").val().length() < 1)
                        alert("Section title is required");
                    else
                        element.find(".save").click();
                });
            }
        };
    });
    FormBuilderApp.directive('jbEditor', function ($rootScope) {
        return {
            restrict: "A",
            scope: {
                control: "=jbEditor"
            },
            templateUrl: "/FormBuilder/AngularEditorTemplate"
        };
    });
    FormBuilderApp.directive('jbEditControl', function ($rootScope) {
        return {
            restrict: 'A',
            scope: {
                type: "=jbEditControl"
            },
            link: function (scope, element, attrs) {
                if (scope.type == "section") {
                    var isOpen = false;
                    element.hover(function () {
                        element.addClass("open");
                        isOpen = true;
                    }, function () {
                        isOpen = false;
                        setTimeout(function () {
                            if (!isOpen)
                                element.removeClass("open");
                        }, 500);
                    });

                    element.find(".NewQuestion").click(function () {
                        if (element.parent().hasClass("closed")) {
                            angular.element(".jb-inner-controll-holder").slideUp();
                            angular.element(".jb-section-title").addClass("closed");
                            element.parent().parent().find(".jb-inner-controll-holder").slideDown();
                            element.parent(".jb-section-title").removeClass("closed");
                        }
                        angular.element("#NewQuestion").click();
                        $rootScope.global.currentSection = element.parents(".JbSection").attr("data-ElementId");
                    });
                    element.find(".EditCaption").click(function () {
                        element.parents(".JbSection").find(".jb-section-title > .edit").click();
                        element.parents(".JbSection").find(".jb-section-title > input").focus();
                    });
                    element.find(".DeleteSection").click(function () {
                        var r = confirm("WARNING:\nBy deleting a section, all of its children will be deleted too!\n\nAre you sure?");
                        if (r == true) {
                            $rootScope.global.deleteInArrayById(element.parents(".JbSection").attr("data-ElementId"), $rootScope.global.form.Elements);
                            element.parents(".JbSection").slideUp(500);
                            setTimeout(function () {
                                element.parents(".JbSection").remove();
                                scope.$apply();
                            }, 500);
                        }
                    });
                } else if (scope.type == "control") {
                    element.find(".EditQuestion").click(function () {
                        $rootScope.global.addOrUpdate.setToUpdate(element.parents(".jb-inner-controll").scope().control);
                    });
                    element.find(".DeleteQuestion").click(function () {
                        var r = confirm("Are you sure?");
                        if (r == true) {
                            $rootScope.global.deleteInArrayById(element.parents(".jb-inner-controll").attr("data-ElementId"), $rootScope.global.form.Elements);
                            element.parents(".jb-inner-controll").css("min-height", 0).slideUp(500);
                            setTimeout(function () {
                                element.parents(".jb-inner-controll").remove();
                                scope.$apply();
                            }, 500);
                        }
                    });
                }
            }
        };
    });
    FormBuilderApp.service('formService', function formService() {
        return JSON.parse('@Html.Raw(ViewBag.DefaultTemplate)');
    });
    FormBuilderApp.controller('formBuilder', ['$scope', '$http', 'formService', '$rootScope', function ($scope, $http, formService, $rootScope) {
        $scope.form = JSON.parse('@Html.Raw(ViewBag.JsonForm)');

        if (!$scope.form)
            $scope.form = {};
        if (!$scope.form.Elements)
            $scope.form.Elements = [];

        $rootScope.global = {};
        $rootScope.global.currentSection = null;

        $scope.elementTypes = formService.elementTypes;
        $scope.Validations = formService.Validations;
        $scope.VisibilityModes = formService.VisibilityMode;

        $scope.removeSpecialChars = function (string) {
            return string.replace(/[^a-zA-Z0-9]/g, "");
        };

        $scope.removeDamagingChars = function (string) {
            return string.replace('"', "").replace("'", "’");
        };

        $scope.validateTextsAndValues = function () {
            if ($scope.currentElement.Value) {
                if ($scope.currentElement.Type === "JbTextBox" ||
                    $scope.currentElement.Type === "JbTextArea" ||
                    $scope.currentElement.Type === "JbParagraph" ||
                    $scope.currentElement.Type === "JbEmail" ||
                    $scope.currentElement.Type === "JbPhone")
                    $scope.currentElement.Value = $scope.removeDamagingChars($scope.currentElement.Value);

                if ($scope.currentElement.Type === "JbNumber")
                    $scope.currentElement.Value = $scope.currentElement.Value.replace(/[^0-9]+/g, "");
            }

            if ($scope.currentElement.Type === "JbDropDown") {
                for (var item in $scope.currentElement.Items) {
                    if ($scope.currentElement.Items[item].Text)
                        $scope.currentElement.Items[item].Text = $scope.removeDamagingChars($scope.currentElement.Items[item].Text);
                    if ($scope.currentElement.Items[item].Value)
                        $scope.currentElement.Items[item].Value = $scope.removeSpecialChars($scope.currentElement.Items[item].Value);
                }
            }

            if ($scope.currentElement.Title) {
                $scope.currentElement.Title = $scope.removeDamagingChars($scope.currentElement.Title);
                $scope.currentElement.Name = $scope.removeSpecialChars($scope.currentElement.Title);
            }
        };

        $scope.deleteInArray = function (index, array) {
            var r = confirm("Are you sure?");
            if (r == true) {
                if (index > -1) {
                    array.splice(index, 1);
                }
            }
        };
        $scope.deleteInArrayById = function (elementId, array) {
            angular.forEach(array, function (val, key) {
                if (val.ElementId == elementId) {
                    array.splice(key, 1);
                    return;
                }
                if (val.Type == "JbSection") {
                    angular.forEach(val.Elements, function (val2, key2) {
                        if (val2.ElementId == elementId) {
                            val.Elements.splice(key2, 1);
                            return;
                        }
                    });
                }
            });
        };
        $scope.sortableOptions = {
            update: function (e, ui) {
            }
        };
        $scope.addNewOptionToArray = function (newTitle, newValue, options) {
            var exists = false;
            angular.forEach(options, function (val, key) {
                if (val.Text == newTitle) {
                    alert("Item already exists...");
                    exists = true;
                }
            });
            if (exists)
                return;
            var item = {
                Text: newTitle,
                Value: newValue
            };
            options.push(item);
        };
        $scope.addOptionWithRandomValue = function (newTitle, options) {
            var newValue = $scope.Random(5, false, true, true, true, false);
            $scope.addNewOptionToArray(newTitle, newValue, options);
        };
        $scope.Random = function (length, allowNumbers, allowChars, allowUppercase, allowLowercase, returnNumber) {
            var random = "", possible = "";
            if (allowNumbers)
                possible += "0123456789";
            if (allowChars) {
                if (allowUppercase)
                    possible += "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
                if (allowLowercase)
                    possible += "abcdefghijklmnopqrstuvwxyz";
            }
            for (var i = 0; i < length; i++)
                random += possible.charAt(Math.floor(Math.random() * possible.length));
            if (returnNumber && allowNumbers && !allowChars)
                return parseInt(random);
            return random;
        };
        $scope.adaptNewElement = function () {
            angular.forEach($scope.elementTypes, function (val, key) {
                if (val.Type == $scope.currentElement.Type) {
                    angular.copy(val, $scope.currentElement);
                }
            });
        };
        $scope.validationChange = function (selectedValidation) {
            var exist;
            if (selectedValidation.IsChecked) {
                exist = false;
                angular.forEach($scope.currentElement.Validations, function (val, key) {
                    if (val.Type == selectedValidation.Type)
                        exist = true;
                });
                if (!exist)
                    $scope.currentElement.Validations.push(selectedValidation);
            } else {
                angular.forEach($scope.currentElement.Validations, function (val, key) {
                    if (val.Type == selectedValidation.Type)
                        $scope.currentElement.Validations.splice(key, 1);
                });
            }
        };
        $scope.checkExistValidation = function (validation) {
            angular.forEach($scope.currentElement.Validations, function (val, key) {
                if (val.Type == validation.Type) {
                    return true;
                }
                if (val.Type == "JbSection") {
                    angular.forEach(val.Elements, function (val2, key2) {
                        if (val2.Type == validation.Type) {
                            return true;
                        }
                    });
                }
            });

            return false;
        };
        $scope.addOrUpdate = {
            processTitle: "Add",
            isUpdating: false,
            setToUpdate: function (element) {
                $scope.addOrUpdate.processTitle = "Save";
                $scope.addOrUpdate.isUpdating = true;
                $scope.currentElement = element;
                $scope.$apply();
            },
            setToAdd: function () {
                $scope.currentElement = $rootScope.global.currentSection = null;
                $scope.addOrUpdate.processTitle = "Add";
                $scope.addOrUpdate.isUpdating = false;
            },
            process: function () {
                if (!$scope.addOrUpdate.isUpdating) {

                    console.log("*********************************** IS ADDING ****************************************")

                    if (!$scope.form)
                        $scope.form = {};
                    if (!$scope.form.Elements)
                        $scope.form.Elements = [];
                    $scope.currentElement.ElementId = $scope.currentElement.Type + $scope.Random(9, true, false, true, true, false);

                    $scope.validateTextsAndValues();

                    if ($scope.currentElement.Name == null || $scope.currentElement.Name == "" || $scope.currentElement.Title == null || $scope.currentElement.Title == "") {
                        alert("Title is reqired.\nPlease enter a title.");
                        return;
                    }
                    if ($rootScope.global.currentSection && $scope.currentElement.Type != "JbSection") {
                        angular.forEach($scope.form.Elements, function (val, key) {
                            if (val.ElementId == $rootScope.global.currentSection) {
                                if (!$scope.form.Elements[key].Elements)
                                    $scope.form.Elements[key].Elements = [];
                                $scope.form.Elements[key].Elements.push($scope.currentElement);
                            }
                        });
                    } else {
                        if ($scope.currentElement.Type == "JbSection") {
                            $scope.form.Elements.push($scope.currentElement);
                            $scope.currentElement = null;
                        } else {
                            alert("Please select a section");
                            return;
                        }
                    }
                    $scope.addOrUpdate.setToAdd();
                } else {
                    console.log("*********************************** IS UPDATING ****************************************")
                    angular.forEach($scope.form.Elements, function (val, key) {
                        if ($scope.currentElement && val.ElementId == $scope.currentElement.ElementId) {
                            $scope.form.Elements[key] = $scope.currentElement;
                            $scope.addOrUpdate.setToAdd();
                            return;
                        }
                        if (val.Type == "JbSection") {
                            var done = false;
                            angular.forEach(val.Elements, function (val2, key2) {
                                if ($scope.currentElement && val2.ElementId == $scope.currentElement.ElementId) {
                                    val.Elements[key2] = $scope.currentElement;
                                    $scope.addOrUpdate.setToAdd();
                                    done = true;
                                    return;
                                }
                            });
                            if (done) {
                                return;
                            }
                            console.log();
                        }
                    });
                }
            }
        };

        $scope.saveSectionTitleEdit = function () {
            //element.find(".save").click();
            $scope.CaptionIsEditing = false;
        };

        $rootScope.global.addOrUpdate = $scope.addOrUpdate;
        $rootScope.global.deleteInArray = $scope.deleteInArray;
        $rootScope.global.deleteInArrayById = $scope.deleteInArrayById;
        $rootScope.global.form = $scope.form;

        $scope.$watchCollection("currentElement", function (newValue, oldValue) {
            if (newValue != oldValue)
                $rootScope.global.currentElement = $scope.currentElement;
        });

    }]);
    angular.bootstrap(angular.element("#ng-app"), ['FormBuilderApp']);
</script>
